export default interface Instantiable<T> {
    new(...args: any[]): T
}

const isInstantiable = (what: any): what is Instantiable<any> => {
    return (typeof what === 'object' || typeof what === 'function') && 'constructor' in what && typeof what.constructor === 'function'
}

export { isInstantiable }
